﻿//~ Create RGB Swatches
//~ This script creates swatches for printing using Adobe Illustrator
//~ It can vary the intensity and color.
//~ Color is defined in RGB space.

//~ Copyright 2015 TechStar International Corp 
//~ www.vistalogics.com     
//~ 678-717-1200

var swatchLabel = "RGB";
var tint = 100; 
var tintStart = 100;
var tintEnd = 100;
var tintStep = 0;

    function nthroot(x, n) {
	  try {
	    var negate = n % 2 == 1 && x < 0;
	    if(negate)
	      x = -x;
	    var possible = Math.pow(x, 1 / n);
	    n = Math.pow(possible, n);
	    if(Math.abs(x - n) < 1 && (x > 0 == n > 0))
	      return negate ? -possible : possible;
	  } catch(e){}
	}

 myDlg = new Window('dialog', "Create RGB Swatches with Intensity Variation");
 myDlg.orientation = 'column';
 myDlg.alignment = 'right';

function createColorDialog()
{
with (myDlg.add('group'))
{
     
     orientation = 'row';
     add('statictext', undefined, "Intensity (0-100%) Start:");
     tintEdit = add('edittext', undefined, "100", {helpTip:"Color intensity"} );
     tintEdit.characters = 6;
     with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "End:");
               tintEndEdit = add('edittext', undefined, "100", {helpTip:"end of Intensity range"} );
               tintEndEdit.characters = 6;
          }
     with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Steps:");
               tintStepEdit = add('edittext', undefined, "0", {helpTip:"Steps for Intensity range"} );
               tintStepEdit.characters = 6;
          }
}

with (myDlg.add('group'))
{
     orientation = 'row';
     with (add('panel'))
     {
          orientation = 'column';
          add('statictext', undefined, "Starting values");
          with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Red");
               redEdit = add('edittext', undefined, "0", {helpTip:"RGB value of RED goes here"} );
               redEdit.characters = 6;
          }
          with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Green");
               grnEdit = add('edittext', undefined, "0", {helpTip:"RGB value of GREEN goes here"} );
               grnEdit.characters = 6;
          }
          with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Blue");
               bluEdit = add('edittext', undefined, "0", {helpTip:"RGB value of BLUE goes here"} );
               bluEdit.characters = 6;
          }
     }
     with (add('panel'))
     {
          orientation = 'column';
          add('statictext', undefined, "Ending values");
          with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Red");
               red2Edit = add('edittext', undefined, "255", {helpTip:"Put End value of RED in here"} );
               red2Edit.characters = 6;
          }
          with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Green");
               grn2Edit = add('edittext', undefined, "255", {helpTip:"Put End value of GREEN in here"} );
               grn2Edit.characters = 6;
          }
          with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Blue");
               blu2Edit = add('edittext', undefined, "255", {helpTip:"Put End value of BLUE in here"} );
               blu2Edit.characters = 6;
          }
     }
    with (add('panel'))
     {
          orientation = 'column';
          add('statictext', undefined, "Steps");
          with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Red");
               red3Edit = add('edittext', undefined, "4", {helpTip:"Number of Red steps"} );
               red3Edit.characters = 6;
          }
          with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Green");
               grn3Edit = add('edittext', undefined, "4", {helpTip:"Number of Green steps"} );
               grn3Edit.characters = 6;
          }
          with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Blue");
               blu3Edit = add('edittext', undefined, "4", {helpTip:"Number of Blue steps"} );
               blu3Edit.characters = 6;
          }
     }
}
with (myDlg.add('group'))
{
     orientation = 'row';
     add('button', undefined, "OK", {helpTip:"Click to create color spread"});
     add('button', undefined, "Cancel", {helpTip:"Click to close this dialog"});
}

myDlg.add('statictext', undefined, "Copyright (c) 2011 VistaLogics Version 1.0");
tintEdit.active = true;
}

createColorDialog ();

function showColorDialog ()
{
   black = new GrayColor();
   black.gray = 100;
   tintStart=Math.max(Math.min(Number(tintEdit.text),100),0);
   tintEnd=Math.max(Math.min(Number(tintEndEdit.text),100),0);
   tintStep=Math.max(Math.min(Number(tintStepEdit.text),100),0);
   if (tintStart>tintEnd)
   {
     tint = tintEnd;
     tintEnd = tintStart;
     tintStart = tint;
    }
  if (tintStep <= 1)
     { 
        if (tintStart >= 0) {
           tintEnd = tintStart;
        } else {
           tintStart = tintEnd;
        }
      tintStep = 1;
     } else {
        tintStep = Math.max(Math.round((tintEnd-tintStart)/(tintStep-1)),1);
     }
  for (tint=tintStart;tint<=tintEnd;tint+=tintStep)
  {
     var docRef = documents.add(DocumentColorSpace.RGB);
     var charStyle = docRef.characterStyles.add("rgbText");
     // set character attributes
     var charAttr = charStyle.characterAttributes;
     charAttr.size = 10;
     charAttr.tracking = 0;
     charAttr.capitalization = FontCapsOption.ALLCAPS;
     var textColor = new RGBColor();
     textColor.red = 0;
     textColor.green = 0;
     textColor.blue = 255;
     charAttr.fillColor = textColor;

     if (app.documents.length == 0)
          app.documents.add(DocumentColorSpace.RGB);
 
     //rows = Number(rowsEdit.text);
     swatchLabel = "RGB ("+tint+")";
     red = Number(redEdit.text); redend = Number(red2Edit.text);
     if (red>redend)
     {
         redStore = red;
         red = redend;
         redend = redStore;
       }
     redstep = Math.max(Number(red3Edit.text),1);
     //redstep = Math.round((redend - red) / (rows*cols-1));
     grn = Number(grnEdit.text); grnend = Number(grn2Edit.text); 
      if (grn>grnend) 
      {
         grnStore = grn;
         grn = grnend;
         grnend = grnStore;
       }
      grnstep =  Math.max(Number(grn3Edit.text),1);
      blu = Number(bluEdit.text); bluend = Number(blu2Edit.text); 
       if (blu>bluend) 
      {
         bluStore = blu;
         blu = bluend;
         bluend = bluStore;
       }
      blustep =  Math.max(Number(blu3Edit.text),1);     
      //blustep = Math.round((bluend - blu) / (rows*cols-1));
      // alert( redstep + " " + grnstep + " " + blustep,"RGB Step");
      //Number of colors for R G and B - minimum of 1
      rows = Math.ceil(nthroot (Math.abs(redstep * blustep * grnstep), 2));
      cols = rows;
      //
      redstep = Math.max(Math.round((redend + 1 - red)/redstep),1);
      grnstep = Math.max(Math.round((grnend + 1 - grn)/grnstep),1);
      blustep = Math.max(Math.round((bluend + 1 - blu)/blustep),1);
      //alert( rows + " " + cols + " " + red + " " + grn + " " + blu +  " " + redstep + " " + grnstep + " " + blustep + " " + redend + " " + grnend + " " + bluend ,"rows cols RGB Step End");
      height = app.activeDocument.height / rows;
      width = app.activeDocument.width / cols;
      // Modify Character Size
       charAttr.size = Math.round(40/cols);
      var r = red;
      var g = grn;
      var b = blu;
     
      var x = 1
      var y = 1;
      countRect = 0;

      var color = new RGBColor();
      for ( r=red;r<=redend; r+=redstep)
           {
                for ( g=grn;g<=grnend;g+=grnstep)
                  {
                        for ( b=blu;b<=bluend; b+=blustep)
                        {
                            countRect++;
                            countRect=Math.min(countRect,rows*cols);
                            y =countRect%cols ;  if (y==0) y = cols;                        
                            x = Math.ceil(countRect/cols)-1;
                            //~ alert( rows+" " +cols +" "+countRect + " " + r + " " + g + " " + b + "  " + x + " " + y,"Count RGB xy");
                            // hsb= rgbToHsb(r,g,b);
                            color.red = r;
                            color.green = g;
                            color.blue = b; 
                            rect = app.activeDocument.pathItems.rectangle (app.activeDocument.height-(y+0.1)*height, (x+0.1)*width, width*0.8, height*0.8);
                            rect.opacity = tint;
                            rect.strokeColor = black;
                            rect.strokeWidth = 0.5;
                            rect.fillColor = color;
                            t = app.activeDocument.textFrames.add();
                            charStyle.applyTo(t.textRange);
                            t.left = (x+0.5)*width;
                            t.top = app.activeDocument.height-(y+0.9)*height;
                            t.contents =  swatchLabel+"  "+r+" "+g+" "+b;
                            t.paragraphs[0].justification = Justification.CENTER;
                            redraw();
                       }
                  }
              }
        }
     
 }

if (myDlg.show()==1)
{
    showColorDialog ();
}